---
image: registry.gitlab.com/gitlab-org/terraform-images/stable:latest

variables:
  # Global
  TF_ROOT: ${CI_PROJECT_DIR}
  # Credentials
  CIVO_TOKEN: ${VAR_CIVO_TOKEN}
  TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/${CI_PROJECT_NAME}
  #TF_HTTP_PASSWORD: ${VAR_GITLAB_USERNAME}
  #TF_HTTP_PASSWORD: ${VAR_GITLAB_PASSWORD}
  #TF_USERNAME: ${VAR_GITLAB_USERNAME}
  #TF_PASSWORD: ${VAR_GITLAB_PASSWORD}
  # HTTP Backend settings
  #TF_HTTP_ADDRESS: "https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/terraform/state/${CI_PROJECT_NAME}"
  #TF_HTTP_LOCK_ADDRESS: "${TF_HTTP_ADDRESS}/lock"
  #TF_HTTP_LOCK_METHOD: "POST"
  #TF_HTTP_UNLOCK_ADDRESS: "${TF_HTTP_ADDRESS}/lock"
  #TF_HTTP_UNLOCK_METHOD: "DELETE"
  #TF_HTTP_RETRY_WAIT_MIN: 5

cache:
  key: ${CI_PROJECT_NAME}
  paths:
    - ${TF_ROOT}/.terraform

stages:
  - prepare
  - validate
  - build
  - deploy

init:
  stage: prepare
  script:
    - gitlab-terraform init

validate:
  stage: validate
  script:
    - gitlab-terraform validate

plan:
  stage: build
  script:
    - gitlab-terraform plan
    - gitlab-terraform plan-json
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json

apply:
  stage: deploy
  environment:
    name: production
  script:
    - gitlab-terraform apply
  dependencies:
    - plan
  when: manual
  only:
    - master
